#!/usr/bin/env python

from commands import getoutput
import dbus
import signal
import string
from time import sleep
from os import system
import sys

awn = ""
alternate = 1
current_cover = "-"
minutes = -1
secs = 0

# dbus connection
def get_dbus_connection():
	print "creating dbus object",
    	bus = dbus.SessionBus()
    	try:
		obj = bus.get_object("com.google.code.Awn", "/com/google/code/Awn")
    	except:
        	print "no service provided"
        	return ""
    	return dbus.Interface(obj, "com.google.code.Awn")

# termination handling
def cleanup():
	global current_cover
    	current_cover = "-"

def sigterm_handler(signum, frame):
        print "unsetting cover and progress"
        if getoutput("pidof avant-window-navigator") != "":
            try:
                awn.UnsetInfoByName("amarok")
                awn.UnsetTaskIconByName("amarok")
	    except:
		print "unexpected Error"
        sys.exit(0)

signal.signal(signal.SIGTERM, sigterm_handler)

#if getoutput("pidof avant-window-navigator") != "":
#    awn = get_dbus_connection()
#    try:
#        awn.UnsetInfoByName(str(task))
#        awn.UnsetTaskIconByName(str(task))
#    except:
#	print "unexpected Error"

# main loop
amarokpid = getoutput("pidof amarokapp") #pid should always be != "" since the script is run by amarok
while(1):
	if getoutput("pidof avant-window-navigator") != "":#check if awn is running, otherwise continue, don't die!
		print "\nawn is running\n"		
		if awn == "":
            		awn = get_dbus_connection()
        	task = awn.GetTaskByPid(int(amarokpid)); #get amarok task name in awn
		print "amarok task is " + task;
		if task != "": #if there is no task we can skip
			print "there is a task"
			if (getoutput('dcop amarok player isPlaying') == "true"):
			    	print "amarok is playing a track"    
		    		total = int(getoutput('dcop amarok player trackTotalTime 2> /dev/null'))
			    	if total > 0:
					print "setting remaining time",
					current = int(getoutput('dcop amarok player trackCurrentTime 2> /dev/null'))
					#rem = int(total - current)
					minutes = current/60
					secs = current%60
					print str(minutes)+':'+string.zfill(secs,2)
					try:
				   	 	awn.SetInfoByName(str(task),str(minutes)+':'+string.zfill(secs,2))
				    		print "[done]"
					except:
				    		print "unexpected Error" 
					print "setting cover",
					cover = getoutput('dcop amarok player coverImage 2> /dev/null')
					print "[found:",cover,"]"
					if cover.find('nocover.png') < 0 and (current_cover != cover or current_cover == "" or current_cover == "-"):
				    		coverpath = "cp "+cover+" /tmp/amarok-cover.png"
				    		system(coverpath)
				    		current_cover = cover
				    		try:
				        		awn.SetTaskIconByName(str(task), "/tmp/amarok-cover.png")
				        		print "[done:new]"
				    		except:
				        		print "unexpected Error" 
					elif cover.find('nocover.png') >= 0:
				    		try:
				        		awn.UnsetTaskIconByName(str(task))
		    		    		except:
							print "unexpected Error"
					else:	
				    		print "[done:old]"
			    	else:
					print "not playing"
					cleanup()
			elif getoutput('dcop amarok player status')=='1':
		   		print "paused"
			    	if minutes == -1:
					total = int(getoutput('dcop amarok player trackTotalTime 2> /dev/null'))
					current = int(getoutput('dcop amarok player trackCurrentTime 2> /dev/null'))
					#rem = int(total - current)
					minutes = current/60
					secs = current%60
				print str(minutes)+':'+string.zfill(secs,2)
				awn.SetInfoByName(str(task),str(minutes)+':'+string.zfill(secs,2))
			    	print "[done]"
				print "setting cover"
				cover = getoutput('dcop amarok player coverImage 2> /dev/null')
				if cover.find('nocover.png') < 0 and (current_cover != cover or current_cover == "" or current_cover == "-"):
			    		coverpath = "cp "+cover+" /tmp/amarok-cover.png"
			    		system(coverpath)
			    		current_cover = cover
			    		awn.SetTaskIconByName (str(task), "/tmp/amarok-cover.png")
			        	print "[done:new]"
				elif cover.find('nocover.png') >= 0:
			    		awn.UnsetTaskIconByName(str(task))
				else:	
			    		print "[done:old]"			
			    	if alternate:
					awn.SetInfoByName(str(task),str(minutes)+':'+string.zfill(secs,2))
			    	else:
					awn.SetInfoByName(str(task),'pause')
	    			alternate = 1-alternate
			else:
		    		print "not playing"
			    	cleanup()
		else:
			print "there is no task"
			cleanup()
	else:	
		print "\nawn is not running\n"	
		awn=""
		cover="-"
		minutes = -1
	sleep(1)
